package com.agri.system.mapper;

import java.time.LocalDateTime;
import java.util.List;
import java.util.Map;

import com.agri.system.domain.SysAgriAlarmRelation;
import com.agri.system.domain.SysDtuData;
import com.baomidou.mybatisplus.core.mapper.BaseMapper;
import org.apache.ibatis.annotations.Param;

/**
 * DTU温湿度上报数据Mapper接口
 * 
 * @author agri
 * @date 2025-12-23
 */
public interface SysDtuDataMapper extends BaseMapper<SysDtuData>
{
    /**
     * 查询DTU温湿度上报数据
     * 
     * @param id DTU温湿度上报数据主键
     * @return DTU温湿度上报数据
     */
    public SysDtuData selectSysDtuDataById(Long id);

    /**
     * 查询DTU温湿度上报数据列表
     * 
     * @param sysDtuData DTU温湿度上报数据
     * @return DTU温湿度上报数据集合
     */
    public List<SysDtuData> selectSysDtuDataList(SysDtuData sysDtuData);

    SysDtuData findDtuDataByInfo(SysDtuData sysDtuData);

    /**
     * 新增DTU温湿度上报数据
     * 
     * @param sysDtuData DTU温湿度上报数据
     * @return 结果
     */
    public int insertSysDtuData(SysDtuData sysDtuData);

    /**
     * 修改DTU温湿度上报数据
     * 
     * @param sysDtuData DTU温湿度上报数据
     * @return 结果
     */
    public int updateSysDtuData(SysDtuData sysDtuData);

    /**
     * 删除DTU温湿度上报数据
     * 
     * @param id DTU温湿度上报数据主键
     * @return 结果
     */
    public int deleteSysDtuDataById(Long id);

    /**
     * 批量删除DTU温湿度上报数据
     * 
     * @param ids 需要删除的数据主键集合
     * @return 结果
     */
    public int deleteSysDtuDataByIds(Long[] ids);

    List<Map<String, Object>> getLastDtuDataByImeiList(@Param("imeiList") List<String> imeiList);


    List<SysDtuData> getHistoryData(
            @Param("imei") String imei,
            @Param("startTime") LocalDateTime startTime,
            @Param("endTime") LocalDateTime endTime
    );

}
